<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.3) on Sun May 26 21:48:59 CEST 2019 -->
<title>Shape</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2019-05-26">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Shape";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":6,"i3":6,"i4":6,"i5":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.david.geo.shapes</a></div>
<h2 title="Class Shape" class="title">Class Shape</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../primitive/Primitive.html" title="class in org.david.geo.primitive">org.david.geo.primitive.Primitive</a></li>
<li>
<ul class="inheritance">
<li>org.david.geo.shapes.Shape</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><code><a href="../primitive/PrimitiveInterface.html" title="interface in org.david.geo.primitive">PrimitiveInterface</a></code></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><code><a href="Ellipse.html" title="class in org.david.geo.shapes">Ellipse</a></code>, <code><a href="Rectangle.html" title="class in org.david.geo.shapes">Rectangle</a></code></dd>
</dl>
<hr>
<pre>public abstract class <span class="typeNameLabel">Shape</span>
extends <a href="../primitive/Primitive.html" title="class in org.david.geo.primitive">Primitive</a></pre>
<div class="block">This abstract class define all attributes to define a <code>Shape</code>
 and extends from <code>Primitive</code>.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.0</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">Shape</a></span>()</code></th>
<td class="colLast">
<div class="block">default constructor.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(org.david.geo.style.Style,org.david.geo.shapes.Point)">Shape</a></span>&#8203;(<a href="../style/Style.html" title="class in org.david.geo.style">Style</a>&nbsp;s,
     <a href="Point.html" title="class in org.david.geo.shapes">Point</a>&nbsp;op)</code></th>
<td class="colLast">
<div class="block">create a shape from an origin point.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#fillAndDraw(java.awt.Graphics2D,java.awt.Shape)">fillAndDraw</a></span>&#8203;(java.awt.Graphics2D&nbsp;g2,
           java.awt.Shape&nbsp;s)</code></th>
<td class="colLast">
<div class="block">fill a <code>Shape</code> and draw the stroke of
 a <code>java.awt.Rectangle2D</code> or a <code>java.awt.Ellipse2D</code>.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="Point.html" title="class in org.david.geo.shapes">Point</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getOrigin()">getOrigin</a></span>()</code></th>
<td class="colLast">
<div class="block">get the origin point.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>abstract double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getPerimeter()">getPerimeter</a></span>()</code></th>
<td class="colLast">
<div class="block">get the perimeter of the shape.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>abstract double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getSurface()">getSurface</a></span>()</code></th>
<td class="colLast">
<div class="block">get the surface of the shape.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setBoundingBox(int,int)">setBoundingBox</a></span>&#8203;(int&nbsp;widthBB,
              int&nbsp;heightBB)</code></th>
<td class="colLast">
<div class="block">set the bounding box of the shape.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setOrigin(org.david.geo.shapes.Point)">setOrigin</a></span>&#8203;(<a href="Point.html" title="class in org.david.geo.shapes">Point</a>&nbsp;p)</code></th>
<td class="colLast">
<div class="block">set new origin point.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.org.david.geo.primitive.Primitive">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.david.geo.primitive.<a href="../primitive/Primitive.html" title="class in org.david.geo.primitive">Primitive</a></h3>
<code><a href="../primitive/Primitive.html#getStyle()">getStyle</a>, <a href="../primitive/Primitive.html#getTransform()">getTransform</a>, <a href="../primitive/Primitive.html#setStyle(org.david.geo.style.Style)">setStyle</a>, <a href="../primitive/Primitive.html#setTransform(org.david.geo.transform.Transform)">setTransform</a>, <a href="../primitive/Primitive.html#transform(java.awt.Graphics2D)">transform</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.org.david.geo.primitive.PrimitiveInterface">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.david.geo.primitive.<a href="../primitive/PrimitiveInterface.html" title="interface in org.david.geo.primitive">PrimitiveInterface</a></h3>
<code><a href="../primitive/PrimitiveInterface.html#draw(java.awt.Graphics)">draw</a></code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;(org.david.geo.style.Style,org.david.geo.shapes.Point)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Shape</h4>
<pre>public&nbsp;Shape&#8203;(<a href="../style/Style.html" title="class in org.david.geo.style">Style</a>&nbsp;s,
             <a href="Point.html" title="class in org.david.geo.shapes">Point</a>&nbsp;op)</pre>
<div class="block">create a shape from an origin point.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - style</dd>
<dd><code>op</code> - origin point</dd>
</dl>
</li>
</ul>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Shape</h4>
<pre>public&nbsp;Shape()</pre>
<div class="block">default constructor.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="getOrigin()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getOrigin</h4>
<pre class="methodSignature">public&nbsp;<a href="Point.html" title="class in org.david.geo.shapes">Point</a>&nbsp;getOrigin()</pre>
<div class="block">get the origin point.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Point returned</dd>
</dl>
</li>
</ul>
<a id="setOrigin(org.david.geo.shapes.Point)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setOrigin</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setOrigin&#8203;(<a href="Point.html" title="class in org.david.geo.shapes">Point</a>&nbsp;p)</pre>
<div class="block">set new origin point.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>p</code> - origin point</dd>
</dl>
</li>
</ul>
<a id="setBoundingBox(int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setBoundingBox</h4>
<pre class="methodSignature">public abstract&nbsp;void&nbsp;setBoundingBox&#8203;(int&nbsp;widthBB,
                                    int&nbsp;heightBB)</pre>
<div class="block">set the bounding box of the shape. (abstract)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>widthBB</code> - width of the bounding box</dd>
<dd><code>heightBB</code> - height of the bounding box</dd>
</dl>
</li>
</ul>
<a id="getPerimeter()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPerimeter</h4>
<pre class="methodSignature">public abstract&nbsp;double&nbsp;getPerimeter()</pre>
<div class="block">get the perimeter of the shape.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>perimeter computed</dd>
</dl>
</li>
</ul>
<a id="getSurface()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSurface</h4>
<pre class="methodSignature">public abstract&nbsp;double&nbsp;getSurface()</pre>
<div class="block">get the surface of the shape.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>surface computed</dd>
</dl>
</li>
</ul>
<a id="fillAndDraw(java.awt.Graphics2D,java.awt.Shape)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>fillAndDraw</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;fillAndDraw&#8203;(java.awt.Graphics2D&nbsp;g2,
                        java.awt.Shape&nbsp;s)</pre>
<div class="block">fill a <code>Shape</code> and draw the stroke of
 a <code>java.awt.Rectangle2D</code> or a <code>java.awt.Ellipse2D</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>g2</code> - <code>Graphics2D</code> class</dd>
<dd><code>s</code> - shape to draw</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
